<?php

class adminatributController extends baseadminController {
  
  function __construct() {
    $this->controller_name = 'Atributy produktů';
    $this->controller_fname = 'adminatribut';
    $this->controller_info = 'Správa atributů produktu. Slouží pro výběr z omezeného množství hodnot. U produktu bude zobrazena ve tvaru: Titul: Hodnota atributu.';
    $this->entita_classname = 'Atribut';
    parent::__construct();
  }

  public function seznam($args) {

    $entita = new $this->entita_classname();
    $table_id = 'seznamAtribut';

    $this->registry->jscript->addJqFunction('"#'.$table_id.'"', 'tablesorter','','','','','','document_ready');
/*
    $query = array();
    $query[] = 'SELECT E.*, S.NAZEV AS S_NAZEV,
     (SELECT COUNT(*) FROM [HODNOTA_ATRIBUTU] WHERE ID_ATR = S.ID) AS POCET_HODNOT FROM ['.$entita->table.'] AS E';
    array_push($query,'INNER JOIN [STAV] AS S ON S.STAV_ID = E.STAV AND S.ENTITA = %s',$entita->table);
*/
    $query = $entita->getAllQuery();
    $filtr_query = array();
    $this->setFilter($filtr_query, $entita);
    $this->myOrder($filtr_query, $entita);
    $strankovani = $this->addLimit($query, $filtr_query ,$entita);
		$query = array_merge($query,$filtr_query);
//$result = dibi::test($query);
    $result = dibi::query($query);
    $zaznamy = $result->fetchAll();
    unset($result);

    array_walk($zaznamy,
      'Tools::addLink',
      array(
        'UPRAVIT' => array(
          'link' => Tools::controllerlink($this->controller_fname, 'upravit'),
          'addindex' => 'ID',
          'text'	 => ICO_UPRAVIT
        ),
        'SMAZAT' => array(
          'link' => Tools::controllerlink($this->controller_fname, 'smazat'),
          'addindex' => 'ID',
          'text'	 => ICO_SMAZAT
        ),
				'HODNOTY' => array(
          'link' => Tools::controllerlink('adminatributhodnota', 'seznam', array('atribut')),
          'addindex' => 'ID',
          'text'	 => ICO_HODNOTY
        )
      )
    );    
    
    $hlavicka = array(
      'ID' => 'Id',
      'NAZEV' => 'Název',
      'TITUL' => 'Titulek',
      'POPIS' => 'Popis',
      'S_NAZEV' => 'Stav',
      'UPRAVIT' => '',
    	'SMAZAT'  => '',
      'HODNOTY' => ''
    );
     
    $obsah_css = array(
      'ID' => 'a_c',
      'S_NAZEV' => 'a_c',
      'UPRAVIT' => 'a_c',
    	'SMAZAT'  => 'a_c',
	  	'HODNOTY' => 'a_c'
    );
    
    $hlavicka_css = array(
      'UPRAVIT' => 'nosort',
    	'SMAZAT'  => 'nosort',
      'HODNOTY' => 'nosort'
    );
    $this->thCss($hlavicka_css);

    $this->html = $this->getTable($table_id, $hlavicka, $zaznamy,
      array('class' => 'seznam tablesorter', 'summary' => $this->controller_name ),
      $obsah_css, array('ID', 'HODNOTY'), $hlavicka_css, 'multisort', $entita->filtry, false
    );
		$this->html .= '<div class="strankovani">'.$strankovani.'</div></form>';
    $this->setView();

  }

  public function pridat($args) {

    $form_id = 'PridatAtributForm';
    $entita = new $this->entita_classname();

    if ($this->registry->form_send) {

      if (Validate::entita($entita,true) !== false) {
        $entita->setFromPost();
        $entita->insert();
        Tools::setMessage('Záznam '.$entita->nazev.' byl přidán', CSS_MESS, 1);
        
      	if (isset($_POST['uloz_pokracuj'])) {
          $redirect = Tools::ControllerLink('adminatributhodnota','pridat', array( $entita->id) );
        }
        elseif (isset($_POST['uloz_seznam'])) {
          $redirect = Tools::ControllerLink($this->controller_fname,'seznam');
        }
        else {
          $redirect = Tools::ControllerLink($this->controller_fname,'pridat');
        }

        Tools::redirect($redirect);
        die;

      }
      else {
        $valid_err = Validate::error();
        Tools::setMessage('Špatně vyplněné údaje'.$valid_err, 'err_mess', CSS_ERR);
      }
    }
    
    $this->registry->jscript->addScript('function nameCopy(){
			var name = $("#nazev").val();
			$("#titul").val(name);
		}
    ');
    
    $form = new Form($form_id, '', 'post', array('class' => 'myForm'));
    $form->setEntitaRef($entita);
    $form->openFieldset('Přidat atribut');
    $form->addLabel(MY, 'nazev', array(), 'Interní označení (nebude zobrazen zákazníkům e-shopu)');
    $form->addInput('text', 'nazev', MY,array(), MY,true);
    $form->addLabel(MY, 'titul', array(), 'Zobrazuje se návštěvníkům e-shopu');
    $form->addInput('text', 'titul', MY,array(), MY);
    $form->addInput('button', 'copy', 'Kopírovat název',array('onclick' => 'nameCopy();'), array(), true);
    $form->addLabel(MY, 'popis' );
    $form->addTextarea('popis', MY, true, array('class' => 'stredni'),array());
    $form->addTag('br');
    $form->addLabel(MY, 'stav' );
    
		if ($form->stateSelect($entita, true)) {
      $form->openTag('div', array('class' => 'bb_l'));
      $form->addTag('hr',array('class' => 'fcleaner '));
      $form->addInput('submit', 'uloz_pokracuj', 'Uložit a vložit hodnoty');
      $form->addInput('submit', 'uloz_vloz', 'Uložit a vložit další');
      $form->addInput('submit', 'uloz_seznam', 'Uložit a zobrazit seznam');
      $form->closeTag();
    }
    else {
      $form->openTag('div', array('class' => 'bb_l'));
      $form->addInnerHTML('Nebyl nalezen žádný počáteční stav entity.<br /><br />');
      $form->addInput('reset', 'reset', 'Vrátit změny');
      $form->closeTag();
    }

    $form->closeFieldset();
    $form->closeForm();

    $this->html = $form->get();

    $this->setView('content.tpl');

  }

  public function upravit($args) {

  	$id = @$args[0];
    $form_id = 'UpravitAtributForm';
		$entita = new $this->entita_classname();

    if ($this->registry->form_send) {
      if (Validate::entita($entita) !== false) {

        if (isset($_POST['uloz'])) {
          $redirect = Tools::ControllerLink('adminatribut','upravit', array( $id) );          
        }
        else {
          $this->naruseni();
        }

        $entita->upravit($id,$form_id);
        Tools::setMessage('Záznam '.$_POST['nazev'].' byl upraven', '', 1);
        Tools::redirect($redirect);
        die;

      }
      else {
        $valid_err = Validate::error();
        Tools::setMessage('Špatně vyplněné údaje'.$valid_err, CSS_ERR);
      }
    }

    $this->registry->jscript->addScript('function nameCopy(){
			var name = $("#nazev").val();
			$("#titul").val(name);
		}
    ');

    $form_value = $entita->loadByID($id, true, $this->registry->postRestore);

    $form = new Form($form_id, '', 'post', array('class' => 'myForm'));
    $form->setEntitaRef($entita);
    $form->setValue($form_value);

    $form->openFieldset('Upravit atribut');
    $form->addLabel(MY, 'nazev', array(), 'Interní označení (nebude zobrazen zákazníkům e-shopu)');
    $form->addInput('text', 'nazev', MY,array(), MY,true);
    $form->addLabel(MY, 'titul', array(), 'Zobrazuje se návštěvníkům e-shopu');
    $form->addInput('text', 'titul', MY,array(), MY);
		$form->addInput('button', 'copy', 'Kopírovat název',array('onclick' => 'nameCopy();'), array(), true);
    $form->addLabel(MY, 'popis' );
    $form->addTextarea('popis', MY, true, array('class' => 'stredni'),array());
    $form->addTag('br');
    $form->addLabel(MY, 'stav' );

    if ($form->stateSelect($entita) == true) {
      $form->addInput('hidden', HASH, MY);
      $form->openTag('div', array('class' => 'bb_l'));
      $form->addTag('hr',array('class' => 'fcleaner '));
      $form->addInput('submit', 'uloz', 'Uložit');
      $form->addInput('reset', 'reset', 'Vrátit změny');
      $form->closeTag();
    }
    else {
      $form->openTag('div', array('class' => 'bb_l'));
      $form->addInnerHTML('Nemáte oprávnění pro modifikaci záznamu v uvedeném stavu.<br /><br />');
      $form->addInput('reset', 'reset', 'Vrátit změny');
      $form->closeTag();
    }
    $form->closeFieldset();
    $this->html = $form->get();

    $this->setView('content.tpl');
  }

  public function smazat($args) {

		$form_id = 'smazatAtribut';
		$id = @$args[0];
		$entita = new $this->entita_classname();
		
		if ($this->registry->form_send) {
			$my_id = @$this->registry->$form_id;

			if ( $my_id == $id) {
				$entita->delete($id);
				Tools::setMessage('Záznam byl smazán', '', 1);
				Tools::redirect(Tools::controllerlink($this->controller_fname, 'seznam'));
			}
			else {
      	Tools::setMessage('Neoprávněný pokus o smazání položky!');
      	return $this->seznam(array());
      	die;
			}
		}
		
		$result = dibi::query('SELECT A.*,
  		(SELECT COUNT(*) FROM [HODNOTA_ATRIBUTU] HA
  			WHERE HA.ID_ATR = A.ID) AS HODNOTY,
			(SELECT COUNT(*) FROM [KOMBINACE_HODNOTA] KH
  			INNER JOIN  [HODNOTA_ATRIBUTU] HA ON HA.ID = KH.ID_HATR
  			WHERE HA.ID_ATR = A.ID) AS PRODUKTY
			FROM ATRIBUT A
			WHERE A.ID = %i',$id);
		
		if (count($result) == 0) {
      Tools::setMessage('Požadovaný záznam neexistuje!');
      return $this->seznam(array());
    }

		$r = $result->fetchAll();
		$zaznam = $r[0];

  	if ( $zaznam['PRODUKTY'] > 0 ) {
			$result = dibi::query('SELECT P.ID, P.NAZEV
				FROM [PRODUKT] P
				INNER JOIN KOMBINACE_HODNOTA KH ON KH.ID_PROD = P.ID
				INNER JOIN HODNOTA_ATRIBUTU HA ON HA.ID = KH.ID_HATR
  			WHERE HA.ID_ATR = %i', $id);
			$r = $result->fetchAssoc('ID');
			
			$produkty = '<div class="warning"><h3>Atribut je používán následujícími produkty</h3>';
			$produkty .= '<p><ul class="smazat">'; 
			foreach($r as $row) {
				$produkty .= '<li> #id: '.$row['ID'].' - '.$row['NAZEV'].'</li>';
			}
			$produkty .= '</ul>Chcete-li atribut odstranit, odeberte ho nejprve z uvedených produktů.</p>
			</div>';
		}
		else {
  		$deti = '';
  		if ( $zaznam['HODNOTY'] > 0 ) {
  			$result = dibi::query('SELECT HA.HODNOTA 
  				FROM [HODNOTA_ATRIBUTU] HA
    			WHERE HA.ID_ATR = %i', $id);
  			$r = $result->fetchAssoc('HODNOTA');
  			
  			$deti = '<div class="warning"><h3>Tento Atribut má hodnoty.</h3>';
  			$deti .= '<p>Pokud odstraníte atribut '.$zaznam['NAZEV'].', budou odstraněny i následující hodnoty:<br /><ul class="smazat">'; 
  			foreach($r as $row) {
  				$deti .= '<li>'.$row['HODNOTA'].'</li>';
  			}
  			$deti .= '</ul>Atribut, ani hodnoty nejsou použity u žádného produktu</p>
  			</div>';
  		}
		}
		
		$form = new Form($form_id);
		$form->openFieldset('Smazat záznam');
		if ( $zaznam['PRODUKTY'] > 0 ) {
  		$form->openTag('h3');
  		$form->addInnerHTML('Atribut <b>'.$zaznam['NAZEV'].'</b> nelze smazat!');
  		$form->closeTag();
  		$form->addInnerHTML($produkty);
      $form->openTag('div', array('class' => 'bb_l'));
      $form->addTag('hr',array('class' => 'fcleaner '));
      $form->openTag('a', array('href' => Tools::controllerlink($this->controller_fname,'seznam')));
      $form->addInput('button', 'reset', 'Zrušit');
      $form->closeTag();
      $form->closeTag();
		}
		else {
			$this->registry->addPersistent($form_id,$id, 2);
  		$form->openTag('h2');
  		$form->addInnerHTML('Chcete opravdu odstranit atribut <b>'.$zaznam['NAZEV'].'</b> (id: '.$zaznam['ID'].') ?');
  		$form->closeTag();
  		$form->addInnerHTML($deti);
      $form->openTag('div', array('class' => 'bb_l'));
      $form->addTag('hr',array('class' => 'fcleaner '));
      $form->addInput('submit', 'uloz', 'Smazat');
      $form->openTag('a', array('href' => Tools::controllerlink($this->controller_fname,'seznam')));
      $form->addInput('button', 'reset', 'Zrušit');
      $form->closeTag();
      $form->closeTag();
		}

    
    $this->html = $form->get();
    $this->setView('content.tpl');
		
	}

}
?>